## NMSetting8021x NMSetting8021x |

## Synopsis

    enum                NMSetting8021xCKType;
    #define             NM_SETTING_802_1X_SETTING_NAME
    enum                NMSetting8021xError;
    #define             NM_TYPE_SETTING_802_1X_ERROR
    #define             NM_SETTING_802_1X_ERROR
    GQuark              nm_setting_802_1x_error_quark       (void);
    #define             NM_SETTING_802_1X_EAP
    #define             NM_SETTING_802_1X_IDENTITY
    #define             NM_SETTING_802_1X_ANONYMOUS_IDENTITY
    #define             NM_SETTING_802_1X_CA_CERT
    #define             NM_SETTING_802_1X_CA_PATH
    #define             NM_SETTING_802_1X_CLIENT_CERT
    #define             NM_SETTING_802_1X_PHASE1_PEAPVER
    #define             NM_SETTING_802_1X_PHASE1_PEAPLABEL
    #define             NM_SETTING_802_1X_PHASE1_FAST_PROVISIONING
    #define             NM_SETTING_802_1X_PHASE2_AUTH
    #define             NM_SETTING_802_1X_PHASE2_AUTHEAP
    #define             NM_SETTING_802_1X_PHASE2_CA_CERT
    #define             NM_SETTING_802_1X_PHASE2_CA_PATH
    #define             NM_SETTING_802_1X_PHASE2_CLIENT_CERT
    #define             NM_SETTING_802_1X_PASSWORD
    #define             NM_SETTING_802_1X_PRIVATE_KEY
    #define             NM_SETTING_802_1X_PRIVATE_KEY_PASSWORD
    #define             NM_SETTING_802_1X_PHASE2_PRIVATE_KEY
    #define             NM_SETTING_802_1X_PHASE2_PRIVATE_KEY_PASSWORD
    #define             NM_SETTING_802_1X_PIN
    #define             NM_SETTING_802_1X_PSK
    #define             NM_SETTING_802_1X_SYSTEM_CA_CERTS
                        NMSetting8021x;
    GType               nm_setting_802_1x_get_type          (void);
    NMSetting*          nm_setting_802_1x_new               (void);
    guint32             nm_setting_802_1x_get_num_eap_methods
                                                            (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_eap_method    (NMSetting8021x *setting,
                                                             guint32 i);
    gboolean            nm_setting_802_1x_add_eap_method    (NMSetting8021x *setting,
                                                             const char *eap);
    void                nm_setting_802_1x_remove_eap_method (NMSetting8021x *setting,
                                                             guint32 i);
    void                nm_setting_802_1x_clear_eap_methods (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_identity      (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_anonymous_identity
                                                            (NMSetting8021x *setting);
    const GByteArray*   nm_setting_802_1x_get_ca_cert       (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_ca_path       (NMSetting8021x *setting);
    gboolean            nm_setting_802_1x_set_ca_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);
    const GByteArray*   nm_setting_802_1x_get_client_cert   (NMSetting8021x *setting);
    gboolean            nm_setting_802_1x_set_client_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);
    const char*         nm_setting_802_1x_get_phase1_peapver
                                                            (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_phase1_peaplabel
                                                            (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_phase1_fast_provisioning
                                                            (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_phase2_auth   (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_phase2_autheap
                                                            (NMSetting8021x *setting);
    const GByteArray*   nm_setting_802_1x_get_phase2_ca_cert
                                                            (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_phase2_ca_path
                                                            (NMSetting8021x *setting);
    gboolean            nm_setting_802_1x_set_phase2_ca_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);
    gboolean            nm_setting_802_1x_get_system_ca_certs
                                                            (NMSetting8021x *setting);
    const GByteArray*   nm_setting_802_1x_get_phase2_client_cert
                                                            (NMSetting8021x *setting);
    gboolean            nm_setting_802_1x_set_phase2_client_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);
    const char*         nm_setting_802_1x_get_password      (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_pin           (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_psk           (NMSetting8021x *setting);
    const GByteArray*   nm_setting_802_1x_get_private_key   (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_private_key_password
                                                            (NMSetting8021x *setting);
    gboolean            nm_setting_802_1x_set_private_key_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             const char *password,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);
    NMSetting8021xCKType nm_setting_802_1x_get_private_key_type
                                                            (NMSetting8021x *setting);
    const GByteArray*   nm_setting_802_1x_get_phase2_private_key
                                                            (NMSetting8021x *setting);
    const char*         nm_setting_802_1x_get_phase2_private_key_password
                                                            (NMSetting8021x *setting);
    gboolean            nm_setting_802_1x_set_phase2_private_key_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             const char *password,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);
    NMSetting8021xCKType nm_setting_802_1x_get_phase2_private_key_type
                                                            (NMSetting8021x *setting);

## Object Hierarchy

      GObject
       +----NMSetting
             +----NMSetting8021x

## Properties

      "anonymous-identity"       gchararray            : Read / Write
      "ca-path"                  gchararray            : Read / Write
      "identity"                 gchararray            : Read / Write
      "password"                 gchararray            : Read / Write
      "phase1-fast-provisioning" gchararray            : Read / Write
      "phase1-peaplabel"         gchararray            : Read / Write
      "phase1-peapver"           gchararray            : Read / Write
      "phase2-auth"              gchararray            : Read / Write
      "phase2-autheap"           gchararray            : Read / Write
      "phase2-ca-path"           gchararray            : Read / Write
      "phase2-private-key-password" gchararray            : Read / Write
      "private-key-password"     gchararray            : Read / Write
      "system-ca-certs"          gboolean              : Read / Write / Construct

## Description

## Details

### enum NMSetting8021xCKType

    typedef enum {
    	NM_SETTING_802_1X_CK_TYPE_UNKNOWN = 0,
    	NM_SETTING_802_1X_CK_TYPE_X509,
    	NM_SETTING_802_1X_CK_TYPE_RAW_KEY,
    	NM_SETTING_802_1X_CK_TYPE_PKCS12
    } NMSetting8021xCKType;

### NM_SETTING_802_1X_SETTING_NAME

    #define NM_SETTING_802_1X_SETTING_NAME "802-1x"

### enum NMSetting8021xError

    typedef enum
    {
    	NM_SETTING_802_1X_ERROR_UNKNOWN = 0,
    	NM_SETTING_802_1X_ERROR_INVALID_PROPERTY,
    	NM_SETTING_802_1X_ERROR_MISSING_PROPERTY
    } NMSetting8021xError;

### NM_TYPE_SETTING_802_1X_ERROR

    #define NM_TYPE_SETTING_802_1X_ERROR (nm_setting_802_1x_error_get_type ())

### NM_SETTING_802_1X_ERROR

    #define NM_SETTING_802_1X_ERROR nm_setting_802_1x_error_quark ()

### nm_setting_802_1x_error_quark ()

    GQuark              nm_setting_802_1x_error_quark       (void);

Returns : |

### NM_SETTING_802_1X_EAP

    #define NM_SETTING_802_1X_EAP "eap"

### NM_SETTING_802_1X_IDENTITY

    #define NM_SETTING_802_1X_IDENTITY "identity"

### NM_SETTING_802_1X_ANONYMOUS_IDENTITY

    #define NM_SETTING_802_1X_ANONYMOUS_IDENTITY "anonymous-identity"

### NM_SETTING_802_1X_CA_CERT

    #define NM_SETTING_802_1X_CA_CERT "ca-cert"

### NM_SETTING_802_1X_CA_PATH

    #define NM_SETTING_802_1X_CA_PATH "ca-path"

### NM_SETTING_802_1X_CLIENT_CERT

    #define NM_SETTING_802_1X_CLIENT_CERT "client-cert"

### NM_SETTING_802_1X_PHASE1_PEAPVER

    #define NM_SETTING_802_1X_PHASE1_PEAPVER "phase1-peapver"

### NM_SETTING_802_1X_PHASE1_PEAPLABEL

    #define NM_SETTING_802_1X_PHASE1_PEAPLABEL "phase1-peaplabel"

### NM_SETTING_802_1X_PHASE1_FAST_PROVISIONING

    #define NM_SETTING_802_1X_PHASE1_FAST_PROVISIONING "phase1-fast-provisioning"

### NM_SETTING_802_1X_PHASE2_AUTH

    #define NM_SETTING_802_1X_PHASE2_AUTH "phase2-auth"

### NM_SETTING_802_1X_PHASE2_AUTHEAP

    #define NM_SETTING_802_1X_PHASE2_AUTHEAP "phase2-autheap"

### NM_SETTING_802_1X_PHASE2_CA_CERT

    #define NM_SETTING_802_1X_PHASE2_CA_CERT "phase2-ca-cert"

### NM_SETTING_802_1X_PHASE2_CA_PATH

    #define NM_SETTING_802_1X_PHASE2_CA_PATH "phase2-ca-path"

### NM_SETTING_802_1X_PHASE2_CLIENT_CERT

    #define NM_SETTING_802_1X_PHASE2_CLIENT_CERT "phase2-client-cert"

### NM_SETTING_802_1X_PASSWORD

    #define NM_SETTING_802_1X_PASSWORD "password"

### NM_SETTING_802_1X_PRIVATE_KEY

    #define NM_SETTING_802_1X_PRIVATE_KEY "private-key"

### NM_SETTING_802_1X_PRIVATE_KEY_PASSWORD

    #define NM_SETTING_802_1X_PRIVATE_KEY_PASSWORD "private-key-password"

### NM_SETTING_802_1X_PHASE2_PRIVATE_KEY

    #define NM_SETTING_802_1X_PHASE2_PRIVATE_KEY "phase2-private-key"

### NM_SETTING_802_1X_PHASE2_PRIVATE_KEY_PASSWORD

    #define NM_SETTING_802_1X_PHASE2_PRIVATE_KEY_PASSWORD "phase2-private-key-password"

### NM_SETTING_802_1X_PIN

    #define NM_SETTING_802_1X_PIN "pin"

### NM_SETTING_802_1X_PSK

    #define NM_SETTING_802_1X_PSK "psk"

### NM_SETTING_802_1X_SYSTEM_CA_CERTS

    #define NM_SETTING_802_1X_SYSTEM_CA_CERTS "system-ca-certs"

### NMSetting8021x

    typedef struct _NMSetting8021x NMSetting8021x;

### nm_setting_802_1x_get_type ()

    GType               nm_setting_802_1x_get_type          (void);

Returns : |

### nm_setting_802_1x_new ()

    NMSetting*          nm_setting_802_1x_new               (void);

Returns : |

### nm_setting_802_1x_get_num_eap_methods ()

    guint32             nm_setting_802_1x_get_num_eap_methods
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_eap_method ()

    const char*         nm_setting_802_1x_get_eap_method    (NMSetting8021x *setting,
                                                             guint32 i);

`setting` : |
`i` : |
Returns : |

### nm_setting_802_1x_add_eap_method ()

    gboolean            nm_setting_802_1x_add_eap_method    (NMSetting8021x *setting,
                                                             const char *eap);

`setting` : |
`eap` : |
Returns : |

### nm_setting_802_1x_remove_eap_method ()

    void                nm_setting_802_1x_remove_eap_method (NMSetting8021x *setting,
                                                             guint32 i);

`setting` : |
`i` : |

### nm_setting_802_1x_clear_eap_methods ()

    void                nm_setting_802_1x_clear_eap_methods (NMSetting8021x *setting);

`setting` : |

### nm_setting_802_1x_get_identity ()

    const char*         nm_setting_802_1x_get_identity      (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_anonymous_identity ()

    const char*         nm_setting_802_1x_get_anonymous_identity
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_ca_cert ()

    const GByteArray*   nm_setting_802_1x_get_ca_cert       (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_ca_path ()

    const char*         nm_setting_802_1x_get_ca_path       (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_set_ca_cert_from_file ()

    gboolean            nm_setting_802_1x_set_ca_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);

`setting` : |
`filename` : |
`out_ck_type` : |
`err` : |
Returns : |

### nm_setting_802_1x_get_client_cert ()

    const GByteArray*   nm_setting_802_1x_get_client_cert   (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_set_client_cert_from_file ()

    gboolean            nm_setting_802_1x_set_client_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);

`setting` : |
`filename` : |
`out_ck_type` : |
`err` : |
Returns : |

### nm_setting_802_1x_get_phase1_peapver ()

    const char*         nm_setting_802_1x_get_phase1_peapver
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase1_peaplabel ()

    const char*         nm_setting_802_1x_get_phase1_peaplabel
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase1_fast_provisioning ()

    const char*         nm_setting_802_1x_get_phase1_fast_provisioning
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_auth ()

    const char*         nm_setting_802_1x_get_phase2_auth   (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_autheap ()

    const char*         nm_setting_802_1x_get_phase2_autheap
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_ca_cert ()

    const GByteArray*   nm_setting_802_1x_get_phase2_ca_cert
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_ca_path ()

    const char*         nm_setting_802_1x_get_phase2_ca_path
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_set_phase2_ca_cert_from_file ()

    gboolean            nm_setting_802_1x_set_phase2_ca_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);

`setting` : |
`filename` : |
`out_ck_type` : |
`err` : |
Returns : |

### nm_setting_802_1x_get_system_ca_certs ()

    gboolean            nm_setting_802_1x_get_system_ca_certs
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_client_cert ()

    const GByteArray*   nm_setting_802_1x_get_phase2_client_cert
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_set_phase2_client_cert_from_file ()

    gboolean            nm_setting_802_1x_set_phase2_client_cert_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);

`setting` : |
`filename` : |
`out_ck_type` : |
`err` : |
Returns : |

### nm_setting_802_1x_get_password ()

    const char*         nm_setting_802_1x_get_password      (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_pin ()

    const char*         nm_setting_802_1x_get_pin           (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_psk ()

    const char*         nm_setting_802_1x_get_psk           (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_private_key ()

    const GByteArray*   nm_setting_802_1x_get_private_key   (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_private_key_password ()

    const char*         nm_setting_802_1x_get_private_key_password
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_set_private_key_from_file ()

    gboolean            nm_setting_802_1x_set_private_key_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             const char *password,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);

`setting` : |
`filename` : |
`password` : |
`out_ck_type` : |
`err` : |
Returns : |

### nm_setting_802_1x_get_private_key_type ()

    NMSetting8021xCKType nm_setting_802_1x_get_private_key_type
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_private_key ()

    const GByteArray*   nm_setting_802_1x_get_phase2_private_key
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_get_phase2_private_key_password ()

    const char*         nm_setting_802_1x_get_phase2_private_key_password
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

### nm_setting_802_1x_set_phase2_private_key_from_file ()

    gboolean            nm_setting_802_1x_set_phase2_private_key_from_file
                                                            (NMSetting8021x *setting,
                                                             const char *filename,
                                                             const char *password,
                                                             NMSetting8021xCKType *out_ck_type,
                                                             GError **err);

`setting` : |
`filename` : |
`password` : |
`out_ck_type` : |
`err` : |
Returns : |

### nm_setting_802_1x_get_phase2_private_key_type ()

    NMSetting8021xCKType nm_setting_802_1x_get_phase2_private_key_type
                                                            (NMSetting8021x *setting);

`setting` : |
Returns : |

## Property Details

### The `"anonymous-identity"` property

      "anonymous-identity"       gchararray            : Read / Write

Anonymous identity.

Default value: NULL

### The `"ca-path"` property

      "ca-path"                  gchararray            : Read / Write

CA path.

Default value: NULL

### The `"identity"` property

      "identity"                 gchararray            : Read / Write

Identity.

Default value: NULL

### The `"password"` property

      "password"                 gchararray            : Read / Write

Password.

Default value: NULL

### The `"phase1-fast-provisioning"` property

      "phase1-fast-provisioning" gchararray            : Read / Write

Phase1 fast provisioning.

Default value: NULL

### The `"phase1-peaplabel"` property

      "phase1-peaplabel"         gchararray            : Read / Write

Phase1 PEAP label.

Default value: NULL

### The `"phase1-peapver"` property

      "phase1-peapver"           gchararray            : Read / Write

Phase1 PEAPVER.

Default value: NULL

### The `"phase2-auth"` property

      "phase2-auth"              gchararray            : Read / Write

Phase2 auth.

Default value: NULL

### The `"phase2-autheap"` property

      "phase2-autheap"           gchararray            : Read / Write

Phase2 autheap.

Default value: NULL

### The `"phase2-ca-path"` property

      "phase2-ca-path"           gchararray            : Read / Write

Phase2 auth CA path.

Default value: NULL

### The `"phase2-private-key-password"` property

      "phase2-private-key-password" gchararray            : Read / Write

Phase2 private key password.

Default value: NULL

### The `"private-key-password"` property

      "private-key-password"     gchararray            : Read / Write

Private key password.

Default value: NULL

### The `"system-ca-certs"` property

      "system-ca-certs"          gboolean              : Read / Write / Construct

Use system CA certificates.

Default value: FALSE